KUBERNETES(1)(kubernetes)

Eric Paris Jan 2015

NAME

kubectl logs - Print the logs for a container in a pod

SYNOPSIS

kubectl logs [OPTIONS]

DESCRIPTION

Print the logs for a container in a pod or specified resource. If the pod has only one container, the container name is optional.

OPTIONS

--all-containers=false
    Get all containers' logs in the pod(s).

--all-pods=false
    Get logs from all pod(s). Sets prefix to true.

-c, --container=""
    Print the logs of this container

-f, --follow=false
    Specify if the logs should be streamed.

--ignore-errors=false
    If watching / following pod logs, allow for any errors that occur to be non-fatal

--insecure-skip-tls-verify-backend=false
    Skip verifying the identity of the kubelet that logs are requested from. In theory, an attacker could provide invalid log content back. You might want to use this if your kubelet serving certificates have expired.

--limit-bytes=0
    Maximum bytes of logs to return. Defaults to no limit.

--max-log-requests=5
    Specify maximum number of concurrent logs to follow when using by a selector. Defaults to 5.

--pod-running-timeout=20s
    The length of time (like 5s, 2m, or 3h, higher than zero) to wait until at least one pod is running

--prefix=false
    Prefix each log line with the log source (pod name and container name)

-p, --previous=false
    If true, print the logs for the previous instance of the container in a pod if it exists.

-l, --selector=""
    Selector (label query) to filter on, supports '=', '==', '!=', 'in', 'notin'.(e.g. -l key1=value1,key2=value2,key3 in (value3)). Matching objects must satisfy all of the specified label constraints.

--since=0s
    Only return logs newer than a relative duration like 5s, 2m, or 3h. Defaults to all logs. Only one of since-time / since may be used.

--since-time=""
    Only return logs after a specific date (RFC3339). Defaults to all logs. Only one of since-time / since may be used.

--tail=-1
    Lines of recent log file to display. Defaults to -1 with no selector, showing all log lines otherwise 10, if a selector is provided.

--timestamps=false
    Include timestamps on each line in the log output

OPTIONS INHERITED FROM PARENT COMMANDS

--as=""
    Username to impersonate for the operation. User could be a regular user or a service account in a namespace.

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--as-uid=""
    UID to impersonate for the operation.

--cache-dir="/home/username/.kube/cache"
    Default cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cluster=""
    The name of the kubeconfig cluster to use

--context=""
    The name of the kubeconfig context to use

--disable-compression=false
    If true, opt-out of response compression for all requests to the server

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--match-server-version=false
    Require server version to match client version

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--tls-server-name=""
    Server name to use for server certificate validation. If it is not provided, the hostname used to contact the server is used

--token=""
    Bearer token for authentication to the API server

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

--version=false
    --version, --version=raw prints version information and quits; --version=vX.Y.Z... sets the reported version

--warnings-as-errors=false
    Treat warnings received from the server as errors and exit with a non-zero exit code

EXAMPLE
      # Return snapshot logs from pod nginx with only one container
      kubectl logs nginx

      # Return snapshot logs from pod nginx, prefixing each line with the source pod and container name
      kubectl logs nginx --prefix

      # Return snapshot logs from pod nginx, limiting output to 500 bytes
      kubectl logs nginx --limit-bytes=500

      # Return snapshot logs from pod nginx, waiting up to 20 seconds for it to start running.
      kubectl logs nginx --pod-running-timeout=20s

      # Return snapshot logs from pod nginx with multi containers
      kubectl logs nginx --all-containers=true

      # Return snapshot logs from all pods in the deployment nginx
      kubectl logs deployment/nginx --all-pods=true

      # Return snapshot logs from all containers in pods defined by label app=nginx
      kubectl logs -l app=nginx --all-containers=true

      # Return snapshot logs from all pods defined by label app=nginx, limiting concurrent log requests to 10 pods
      kubectl logs -l app=nginx --max-log-requests=10

      # Return snapshot of previous terminated ruby container logs from pod web-1
      kubectl logs -p -c ruby web-1

      # Begin streaming the logs from pod nginx, continuing even if errors occur
      kubectl logs nginx -f --ignore-errors=true

      # Begin streaming the logs of the ruby container in pod web-1
      kubectl logs -f -c ruby web-1

      # Begin streaming the logs from all containers in pods defined by label app=nginx
      kubectl logs -f -l app=nginx --all-containers=true

      # Display only the most recent 20 lines of output in pod nginx
      kubectl logs --tail=20 nginx

      # Show all logs from pod nginx written in the last hour
      kubectl logs --since=1h nginx

      # Show all logs with timestamps from pod nginx starting from August 30, 2024, at 06:00:00 UTC
      kubectl logs nginx --since-time=2024-08-30T06:00:00Z --timestamps=true

      # Show logs from a kubelet with an expired serving certificate
      kubectl logs --insecure-skip-tls-verify-backend nginx

      # Return snapshot logs from first container of a job named hello
      kubectl logs job/hello

      # Return snapshot logs from container nginx-1 of a deployment named nginx
      kubectl logs deployment/nginx -c nginx-1

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!